function ped16000_ParametrosdeImportacaodePedidos_Controller (ScreenService,ZHPromise, templateManager, General){

     this.adicionar = function(widget){
        var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        widget.newRow();
        widget.currentRow.__is_new = true;
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        this.controlaStatusWidgets(tabbedParametrosImpPedidos, widget.name, false);
        
    };
	
	this.editar = function(widget){
	    var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = true;
        widget.template = widget.templateToForm;
        General.edit(widget);
    };
    
    this.cancelar = function(widget){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        if(widget.currentRow.__is_new === true){    
            widget.parent.widgets.forEach(function(element){
                element.currentRow = {};
            });
        }
	    widget.template = widget.templateToView;
        widget.view();
        widget.reload();
        widget.activate();
        
        var tabbedParametrosImpPedidos = templateManager.container.getWidget('tabbedParametrosImpPedidos');
	    tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly = false;
	    
    };
    
    this.salvarImpPeddistri = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosImpPedidos'), 'autorizacaofornecimento', true);
                var tabbedParametrosImpPedidos =  templateManager.container.getWidget('tabbedParametrosImpPedidos');
                tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosImportacaoPed(tabbedParametrosImpPedidos);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };
   
    this.salvarImpPedsolicita = function(widget){
            General.saveCrud(widget).then(function(sucesso){
                this.controlaStatusWidgets(templateManager.container.getWidget('tabbedParametrosImpPedidos'),'solicitacaodecompras',true);
                var tabbedParametrosImpPedidos =  templateManager.container.getWidget('tabbedParametrosImpPedidos');
                tabbedParametrosImpPedidos.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                widget.view();
                if(currentRow.__is_new == true){
                    this.filtroParametrosImportacaoPed(tabbedParametrosImpPedidos);
                }
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.getAction('editar').isVisible = true;
                widget.getAction('atualizar').isVisible = true;
                widget.getAction('novo').isVisible = false;
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            });
   };

    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });
    };
    
    this.reloadWidgets = function(){
        var widget = templateManager.container.getWidget('tabbedParametrosImpPedidos');
        widget.widgets.forEach(function(element){
            element.reload();
        }.bind(this));
        templateManager.updateTemplate();
    };
    
    this.filtroParametrosImportacaoPed = function(widget){
        var filial = widget.currentRow.CDFILIAL;
        var filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
            }
        ];
        
        General.callRestEngine("ped_pedidos#/crud/paramimppedido_vendedor","FilterData", filtro).then(function(sucesso){
            var resultado = sucesso.dataset.paramimppedido_vendedor[0];
            widget.widgets.forEach(function(value){
                if(resultado && filial) {
                    value.currentRow = resultado;
                    value.getAction('editar').isVisible = true;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }else if(!resultado && filial){
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = true;
                    value.reload();
                }
                else {
                    value.currentRow = {};
                    value.getAction('editar').isVisible = false;
                    value.getAction('atualizar').isVisible = true;
                    value.getAction('novo').isVisible = false;
                    value.reload();
                }
            });
            
        }.bind(this), function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('ped16000_ParametrosdeImportacaodePedidos_Controller', ped16000_ParametrosdeImportacaodePedidos_Controller);
});